import * as React from 'react';
import * as CodeMirror from 'codemirror';
export declare type IMenuItemState = 'enabled' | 'disabled' | 'selected';
export interface IMenuItemRenderProps {
    editor: CodeMirror.Editor;
    name: string;
    state: string;
    tip: string;
}
export interface IMenuItemProps {
    name: string;
    editor: CodeMirror.Editor;
    state?: IMenuItemState;
    tip: string;
    onClick?: (editor: CodeMirror.Editor, name: string, state: string) => void;
    keyboard?: string;
    locale?: string;
    className?: string;
    link?: string;
    render?: (props: IMenuItemRenderProps) => React.ComponentElement<any, any>;
}
declare const MenuItem: (props: IMenuItemProps) => JSX.Element | null;
export default MenuItem;
