/// <reference types="codemirror" />
import * as React from 'react';
import { IMenuItemRenderProps } from './MenuItem';
export declare type ProMarkdownMenuNames = 'bold' | 'br' | 'code' | 'eraser' | 'fullscreen' | 'heading' | 'help' | 'image' | 'ordered-list' | 'quote' | 'italic' | 'link' | 'preview' | 'strikethrough' | 'splitpane' | 'table' | 'unordered-list' | '|';
export interface IMenuItemTips {
    [name: string]: string;
}
export interface IProMarkdownMenuItem {
    name: ProMarkdownMenuNames | string;
    tip: string;
    className?: string;
    render?: (props?: IMenuItemRenderProps) => any;
    onClick?: (editor: CodeMirror.Editor, name: string, state: string) => void;
    link?: string;
}
export interface IProMarkdownProps {
    className?: string;
    initialValue?: string;
    hideMenu?: boolean;
    mode?: {
        name: 'yaml-frontmatter' | 'toml-frontmatter' | 'json-frontmatter';
        base: 'markdown' | 'gfm';
    };
    menu?: IProMarkdownMenuItem[];
    markdownTransformer?: (from: string) => string;
    renderPreview?: (props: {
        value: string;
        frontmatter: string;
    }) => React.ComponentElement<any, any>;
    menuitemTips?: {
        [name: string]: string;
    };
    locale?: string;
    lineNumbers?: boolean;
    helpLink?: string;
    atMounted?: (editor: CodeMirror.Editor) => any;
    atUnmounted?: (editor: CodeMirror.Editor, value: string) => any;
    atChange?: (editor: CodeMirror.Editor, change: CodeMirror.EditorChange, value: string) => any;
    codemirrorOptions?: any;
    menuItemTips?: IMenuItemTips;
}
declare const ProMarkdown: (props: IProMarkdownProps) => JSX.Element;
export default ProMarkdown;
